//+------------------------------------------------------------------+ 
//| SATL.mq4 
//| 
//+------------------------------------------------------------------+ 
#property copyright "Copyright 2002, Finware.ru Ltd." 
#property link "http://www.finware.ru/" 

#property indicator_chart_window 
#property indicator_buffers 1 
#property indicator_color1 Yellow 


extern int SmoothLength = 5;
extern int SmoothPhase  = 0;

//---- buffers 
double SATLBuffer[]; 
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function | 
//+------------------------------------------------------------------+ 
int init() 
{ 
string short_name; 
//---- indicator line 
SetIndexStyle(0,DRAW_LINE); 
SetIndexBuffer(0,SATLBuffer); 
SetIndexDrawBegin(0,64); 
//---- 
return(0); 
} 
//+------------------------------------------------------------------+ 
//| SATL | 
//+------------------------------------------------------------------+ 
int start() 
{ 
int i,counted_bars=IndicatorCounted(); 
double response;
//---- 
if(Bars<=64) return(0); 
//---- initial zero 
if(counted_bars<64) 
for(i=1;i<=0;i++) SATLBuffer[Bars-i]=0.0; 
//---- 
i=Bars-64-1; 
if(counted_bars>=64) i=Bars-counted_bars-1; 
while(i>=0) 
{ 
response=
0.0982862174*Close[i+0] 
+0.0975682269*Close[i+1] 
+0.0961401078*Close[i+2] 
+0.0940230544*Close[i+3] 
+0.0912437090*Close[i+4] 
+0.0878391006*Close[i+5] 
+0.0838544303*Close[i+6] 
+0.0793406350*Close[i+7] 
+0.0743569346*Close[i+8] 
+0.0689666682*Close[i+9] 
+0.0632381578*Close[i+10] 
+0.0572428925*Close[i+11] 
+0.0510534242*Close[i+12] 
+0.0447468229*Close[i+13] 
+0.0383959950*Close[i+14] 
+0.0320735368*Close[i+15] 
+0.0258537721*Close[i+16] 
+0.0198005183*Close[i+17] 
+0.0139807863*Close[i+18] 
+0.0084512448*Close[i+19] 
+0.0032639979*Close[i+20] 
-0.0015350359*Close[i+21] 
-0.0059060082*Close[i+22] 
-0.0098190256*Close[i+23] 
-0.0132507215*Close[i+24] 
-0.0161875265*Close[i+25] 
-0.0186164872*Close[i+26] 
-0.0205446727*Close[i+27] 
-0.0219739146*Close[i+28] 
-0.0229204861*Close[i+29] 
-0.0234080863*Close[i+30] 
-0.0234566315*Close[i+31] 
-0.0231017777*Close[i+32] 
-0.0223796900*Close[i+33] 
-0.0213300463*Close[i+34] 
-0.0199924534*Close[i+35] 
-0.0184126992*Close[i+36] 
-0.0166377699*Close[i+37] 
-0.0147139428*Close[i+38] 
-0.0126796776*Close[i+39] 
-0.0105938331*Close[i+40] 
-0.0084736770*Close[i+41] 
-0.0063841850*Close[i+42] 
-0.0043466731*Close[i+43] 
-0.0023956944*Close[i+44] 
-0.0005535180*Close[i+45] 
+0.0011421469*Close[i+46] 
+0.0026845693*Close[i+47] 
+0.0040471369*Close[i+48] 
+0.0052380201*Close[i+49] 
+0.0062194591*Close[i+50] 
+0.0070340085*Close[i+51] 
+0.0076266453*Close[i+52] 
+0.0080376628*Close[i+53] 
+0.0083037666*Close[i+54] 
+0.0083694798*Close[i+55] 
+0.0082901022*Close[i+56] 
+0.0080741359*Close[i+57] 
+0.0077543820*Close[i+58] 
+0.0073260526*Close[i+59] 
+0.0068163569*Close[i+60] 
+0.0062325477*Close[i+61] 
+0.0056078229*Close[i+62] 
+0.0049516078*Close[i+63] 
+0.0161380976*Close[i+64]; 

if (SmoothLength>1)
 SATLBuffer[i] = iSmooth(response,SmoothLength,SmoothPhase,i);
 else  SATLBuffer[i] = response;



i--; 
} 
return(0); 
} 
//+------------------------------------------------------------------+ 


double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//


double iSmooth(double price, double length, double phase, int i)
{
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[0][k]=price; for(; k<10; k++) wrk[0][k]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax];
      double del2   = price - wrk[r-1][bsmin];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty] = MathAbs(del2); 
         wrk[r][vsum] =	wrk[r-1][vsum] + (wrk[r][volty]-wrk[r-forBar][volty])*div;
   
         //
         //
         //
         //
         //
   
         wrk[r][avolty] = wrk[r-1][avolty]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum]-wrk[r-1][avolty]);
            if (wrk[r][avolty] > 0)
               double dVolty = wrk[r][volty]/wrk[r][avolty]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax] = price; else wrk[r][bsmax] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin] = price; else wrk[r][bsmin] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0] = price + alpha*(wrk[r-1][0]-price);
         wrk[r][1] = (price - wrk[r][0])*(1-beta) + beta*wrk[r-1][1];
         wrk[r][2] = (wrk[r][0] + R*wrk[r][1]);
         wrk[r][3] = (wrk[r][2] - wrk[r-1][4])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3];
         wrk[r][4] = (wrk[r-1][4] + wrk[r][3]); 

   //
   //
   //
   //
   //

   return(wrk[r][4]);
}

